/* 
 *  Copyright (C) 2006 DFKI GmbH
 *  Image Understanding and Pattern Recognition Lab
 *  Author: Christian Kofler <christian.kofler@dfki.de>
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <wx/wx.h>

#include "Application.h"
#include "RootFrame.h"

using namespace std;


IMPLEMENT_APP(wxApplication)


bool wxApplication::OnInit() {

    if (argc < 2) {
        cerr << "usage: firewatch host [port]" << endl << endl;
        exit(-1);
    } else {
        port = 12960;
        if (argc == 3) {
            wxString tmpPort = argv[2];
            tmpPort.ToULong((unsigned long*)&port);
        }
        host = argv[1];
    }

    wxImage::AddHandler(new wxJPEGHandler);
    wxImage::AddHandler(new wxPNGHandler);

    //--- set up GUI
    RootFrame* frame = new RootFrame(0);
    //frame->Centre();
    
    frame->initFireWatch(host, port);
    
    frame->Show(true);
    SetTopWindow(frame);

    
    frame->Refresh();
    return true;
}

wxApplication::~wxApplication() {

}
