/*
 *  Copyright (C) 2006 DFKI GmbH
 *  Image Understanding and Pattern Recognition Lab
 *  Author: Christian Kofler <christian.kofler@dfki.de>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef FIRERESULT_H_
#define FIRERESULT_H_

#include <wx/wx.h>

class FireResult {
public:
    FireResult() { FireResult(wxT("")); }
    FireResult(wxString n, float sc = 0.f) {  name = n; score = sc; }
	virtual ~FireResult() {}
    
    void operator=(const FireResult& rhs) { this->name = rhs.name; this->score=rhs.score;  }
    
    void inline setName(wxString n) { name = n; }
    wxString inline getName() { return name; }
    
    void inline setScore(float sc) { score = sc; }
    float inline getScore() { return score; }
    
private:
    wxString name;
    float score;
    
};

#endif /*FIRERESULT_H_*/
