/* 
 *  Copyright (C) 2006 DFKI GmbH
 *  Image Understanding and Pattern Recognition Lab
 *  Author: Christian Kofler <christian.kofler@dfki.de>
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


// Generated by DialogBlocks (Personal Edition), Do 26 Jan 2006 14:22:16 CET

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "RootFrame.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include <vector>
#include <iostream>
using namespace std;
#include "RootFrame.h"
#include "thumbnailctrl.h"
#include "thumbnaildlg.h"
#include "FireWatch.h"
#include "FireItem.h"

////@begin XPM images
#include "icons/random.xpm"
#include "icons/stock_new-labels-24.xpm"
#include "icons/browse.xpm"
#include "icons/select.xpm"
////@end XPM images

/*!
 * RootFrame type definition
 */

IMPLEMENT_CLASS( RootFrame, wxFrame )

/*!
 * RootFrame event table definition
 */

BEGIN_EVENT_TABLE( RootFrame, wxFrame )

////@begin RootFrame event table entries
    EVT_IDLE( RootFrame::OnIdle )

    EVT_MENU( MENU_FILE_LOAD, RootFrame::OnMenuFileLoad )

    EVT_MENU( MENU_FILE_EXIT, RootFrame::OnMenuFileExitClick )

    EVT_MENU( ID_MENUSETTINGS_SERVER, RootFrame::OnMenuSettingsServer )

    EVT_MENU( ID_MENU, RootFrame::OnMenuClick )

    EVT_MENU( ToolBarRandom, RootFrame::OnRandom )

    EVT_MENU( ToolBarRetrieve, RootFrame::OnToolbarRetrieveSimilar )

    EVT_MENU( ToolBarBrowse, RootFrame::OnToolbarBrowseClick )

    EVT_MENU( ToolBarSelect, RootFrame::OnToolbarSelect )

    EVT_SPINCTRL( ID_SPINCTRL, RootFrame::OnFireResultsUpdated )

    EVT_SLIDER( ID_SLIDER, RootFrame::OnZoom )

////@end RootFrame event table entries

    EVT_THUMBNAIL_ITEM_SELECTED(wxID_ANY, RootFrame::OnItemSelect)
    EVT_THUMBNAIL_ITEM_DESELECTED(wxID_ANY, RootFrame::OnItemDeSelect)
    EVT_THUMBNAIL_LEFT_CLICK(wxID_ANY, RootFrame::OnItemClick)
    EVT_THUMBNAIL_LEFT_DCLICK(wxID_ANY, RootFrame::OnItemDoubleClick)
    EVT_THUMBNAIL_RIGHT_CLICK(wxID_ANY, RootFrame::OnItemRightClick)
    EVT_CONTEXT_MENU(RootFrame::OnItemContextClick)
    
END_EVENT_TABLE()

/*!
 * RootFrame constructors
 */

RootFrame::RootFrame( )
{
}

RootFrame::RootFrame( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Create( parent, id, caption, pos, size, style );
}

/*!
 * RootFrame creator
 */

bool RootFrame::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin RootFrame member initialisation
    fireResultCount = NULL;
    scrolledWindow = NULL;
    zoomSlider = NULL;
////@end RootFrame member initialisation

////@begin RootFrame creation
    wxFrame::Create( parent, id, caption, pos, size, style );

    CreateControls();
    GetSizer()->Fit(this);
    GetSizer()->SetSizeHints(this);
////@end RootFrame creation

    browseDialog = 0;
    selectDialog = 0;
    selectedItem = 0;

    scaleFactor = (float) zoomSlider->GetValue()/100.f;

    return TRUE;
}

/*!
 * Control creation for RootFrame
 */

void RootFrame::CreateControls()
{    
////@begin RootFrame content construction
    // Generated by DialogBlocks, Do 16 Feb 2006 16:25:18 CET (Personal Edition)

    RootFrame* itemFrame1 = this;

    wxMenuBar* menuBar = new wxMenuBar;
    wxMenu* itemMenu3 = new wxMenu;
    itemMenu3->Append(MENU_FILE_LOAD, _("Load ..."), _T(""), wxITEM_NORMAL);
    itemMenu3->Append(ID_MENU_CONNECT, _("Connect Fire servers ..."), _T(""), wxITEM_NORMAL);
    itemMenu3->AppendSeparator();
    itemMenu3->Append(MENU_FILE_EXIT, _("Exit"), _T(""), wxITEM_NORMAL);
    menuBar->Append(itemMenu3, _("File"));
    wxMenu* itemMenu8 = new wxMenu;
    itemMenu8->Append(ID_MENUSETTINGS_SERVER, _("Server settings"), _T(""), wxITEM_NORMAL);
    menuBar->Append(itemMenu8, _("Settings"));
    wxMenu* itemMenu10 = new wxMenu;
    itemMenu10->Append(ID_MENU, _("About FireWatch"), _T(""), wxITEM_NORMAL);
    menuBar->Append(itemMenu10, _("Help"));
    itemFrame1->SetMenuBar(menuBar);

    wxToolBar* itemToolBar12 = CreateToolBar( wxTB_FLAT|wxTB_HORIZONTAL, ID_TOOLBAR1 );
    wxBitmap itemtool13Bitmap(itemFrame1->GetBitmapResource(wxT("icons/random.xpm")));
    itemToolBar12->AddTool(ToolBarRandom, _("random"), itemtool13Bitmap, wxNullBitmap, wxITEM_NORMAL, _("get random images"), _("get random images"));
    itemToolBar12->AddSeparator();
    wxBitmap itemtool15Bitmap(itemFrame1->GetBitmapResource(wxT("icons/stock_new-labels-24.xpm")));
    itemToolBar12->AddTool(ToolBarRetrieve, _("retrieveSimilar"), itemtool15Bitmap, _("retrieve similar"), wxITEM_NORMAL);
    itemToolBar12->AddSeparator();
    wxBitmap itemtool17Bitmap(itemFrame1->GetBitmapResource(wxT("icons/browse.xpm")));
    itemToolBar12->AddTool(ToolBarBrowse, _("browse"), itemtool17Bitmap, wxNullBitmap, wxITEM_NORMAL, _("browse local file system"), _("browse local file system"));
    itemToolBar12->AddSeparator();
    wxBitmap itemtool19Bitmap(itemFrame1->GetBitmapResource(wxT("icons/select.xpm")));
    itemToolBar12->AddTool(ToolBarSelect, _("select"), itemtool19Bitmap, wxNullBitmap, wxITEM_NORMAL, _("select an image region"), _("select an image region"));
    itemToolBar12->AddSeparator();
    wxStaticText* itemStaticText21 = new wxStaticText( itemToolBar12, wxID_STATIC, _("results: "), wxDefaultPosition, wxDefaultSize, 0 );
    itemToolBar12->AddControl(itemStaticText21);
    fireResultCount = new wxSpinCtrl( itemToolBar12, ID_SPINCTRL, _T("1"), wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, 1, 100, 1 );
    fireResultCount->SetHelpText(_("number of Fire results"));
    if (ShowToolTips())
        fireResultCount->SetToolTip(_("number of Fire results"));
    itemToolBar12->AddControl(fireResultCount);
    itemToolBar12->Realize();
    itemFrame1->SetToolBar(itemToolBar12);

    wxBoxSizer* itemBoxSizer23 = new wxBoxSizer(wxVERTICAL);
    itemFrame1->SetSizer(itemBoxSizer23);

    scrolledWindow = new wxThumbnailCtrl( itemFrame1, ID_SCROLLEDWINDOW1, wxDefaultPosition, wxSize(750, 550), wxSUNKEN_BORDER|wxHSCROLL|wxVSCROLL );
    itemBoxSizer23->Add(scrolledWindow, 1, wxGROW|wxALL, 5);
    scrolledWindow->SetScrollbars(1, 1, 1000, 1000);

    wxBoxSizer* itemBoxSizer25 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer23->Add(itemBoxSizer25, 0, wxALIGN_RIGHT|wxALL, 5);

    wxStaticText* itemStaticText26 = new wxStaticText( itemFrame1, wxID_STATIC, _("-"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer25->Add(itemStaticText26, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    zoomSlider = new wxSlider( itemFrame1, ID_SLIDER, 40, 10, 100, wxDefaultPosition, wxSize(150, 15), wxNO_BORDER );
    itemBoxSizer25->Add(zoomSlider, 0, wxALIGN_CENTER_VERTICAL, 0);

    wxStaticText* itemStaticText28 = new wxStaticText( itemFrame1, wxID_STATIC, _("+"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer25->Add(itemStaticText28, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

////@end RootFrame content construction

    // Create custom windows not generated automatically here.

////@begin RootFrame content initialisation

////@end RootFrame content initialisation
}


void RootFrame::initFireWatch(wxString host, unsigned short port) {
    firewatch.setServer(host, port);
    firewatch.initialize();
    
    fireResultCount->SetValue(firewatch.getResultCount());
    
}

void RootFrame::sendNewImage(wxString imageName) {
    std::vector<FireResult>& results  = firewatch.retrieve(imageName, true, true);
    if (results.empty()) {
        wxMessageBox(_("something went wrong...\nMaybe you don't have enough access rights in the Fire image folder?"));
    } else {
        selectedItem = 0;
        displayFireResults(results);
    }
}

void RootFrame::displayFireResults(std::vector<FireResult>& results) {

    scrolledWindow->Freeze();
    scrolledWindow->Clear();

    wxString path = firewatch.getPath();
    
    int maxX = 0;
    int maxY = 0;
    for (unsigned int i = 0; i < results.size(); ++i) {
        // compose full path to image
        results[i].setName(path + wxFILE_SEP_PATH + results[i].getName());
        FireItem* tmpItem = new FireItem(results[i].getName(), scaleFactor);
        wxSize tmpSize = tmpItem->DoGetBestSize();
        if (maxX < tmpSize.x) maxX = tmpSize.x;
        if (maxY < tmpSize.y) maxY = tmpSize.y;
        scrolledWindow->Append(tmpItem);
    }

    scrolledWindow->SetThumbnailImageSize(wxSize(maxX, maxY));    

    scrolledWindow->Thaw();
}


/*!
 * Should we show tooltips?
 */

bool RootFrame::ShowToolTips()
{
    return TRUE;
}

/*!
 * Get bitmap resources
 */

wxBitmap RootFrame::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin RootFrame bitmap retrieval
    wxUnusedVar(name);
    if (name == _T("icons/random.xpm"))
    {
        wxBitmap bitmap(random_xpm);
        return bitmap;
    }
    else if (name == _T("icons/stock_new-labels-24.xpm"))
    {
        wxBitmap bitmap( stock_new_labels_24_xpm);
        return bitmap;
    }
    else if (name == _T("icons/browse.xpm"))
    {
        wxBitmap bitmap(browse_xpm);
        return bitmap;
    }
    else if (name == _T("icons/select.xpm"))
    {
        wxBitmap bitmap(select_xpm);
        return bitmap;
    }
    return wxNullBitmap;
////@end RootFrame bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon RootFrame::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin RootFrame icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end RootFrame icon retrieval
}
/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for Random
 */

void RootFrame::OnRandom( wxCommandEvent& event ) {
    std::vector<FireResult>& results = firewatch.getRandomImages();
    selectedItem = 0;
    displayFireResults(results);
}

/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for MENU_FILE_LOAD
 */

void RootFrame::OnMenuFileLoad(wxCommandEvent & event) {
    // show browse dialog
    if (browseDialog == 0) {
        browseDialog = new wxThumbnailBrowserDialog(this, wxID_ANY);
        wxString initialPath = wxGetCwd();
        if (wxDirExists(initialPath)) browseDialog->SetSelection(initialPath);
    }
    
    if (wxID_OK == browseDialog->ShowModal()) {
        wxString sel = browseDialog->GetSelection();
        if (sel.IsEmpty()) return;
        // copy image to fire folder -> check access rights
        wxString filename = sel.AfterLast(wxFILE_SEP_PATH);
        wxString newFilename = firewatch.getPath() + wxFILE_SEP_PATH + filename;
        // check if file already exists
        /*if (wxFileExists(newFilename)) {
            wxMessageBox(_("a file with this name already exists!"));
            return;
        }*/
        // copy image into Fire location and check if it worked
        if (!wxCopyFile(sel, newFilename, false)) {
            wxMessageBox(_("could not upload image!\nDo you have enough access rights in the Fire image folder?"));
            return;            
        }
        std::vector<FireResult>& results  = firewatch.retrieve(newFilename, true, true);
         if (results.empty()) {
            wxMessageBox(_("something went wrong...\nMaybe you don't have enough access rights in the Fire image folder?"));
        } else {
            selectedItem = 0;
            displayFireResults(results);
        }       
    }


}

/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for MENU_FILE_EXIT
 */

void RootFrame::OnMenuFileExitClick(wxCommandEvent & event) {
    Close(TRUE);
}


/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENU
 */

void RootFrame::OnMenuClick( wxCommandEvent& event )
{
////@begin wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENU in RootFrame.
    // Before editing this code, remove the block markers.
    wxMessageBox(_("FireWatch: GUI for the Flexible Image Retrieval Engine"));
////@end wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENU in RootFrame. 
}


/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER
 */

void RootFrame::OnZoom( wxCommandEvent& event ) {
    scaleFactor = (float) zoomSlider->GetValue()/100.f;

    scrolledWindow->Freeze();
        
    int maxX = 0;
    int maxY = 0;
    for(int i=0; i < scrolledWindow->GetCount(); ++i) {
        FireItem* tmpItem = (FireItem*) scrolledWindow->GetItem(i);
        tmpItem->setScale(scaleFactor);
        wxSize tmpSize = tmpItem->DoGetBestSize();
        if (maxX < tmpSize.x) maxX = tmpSize.x;
        if (maxY < tmpSize.y) maxY = tmpSize.y;
    }
    scrolledWindow->SetThumbnailImageSize(wxSize(maxX, maxY));    

    scrolledWindow->Thaw();

}


void RootFrame::OnItemSelect(wxThumbnailEvent& event) {
    selectedItem = (FireItem*) scrolledWindow->GetItem(event.GetIndex());
    GetToolBar()->EnableTool(ToolBarSelect, true);
    GetToolBar()->EnableTool(ToolBarRetrieve, true);
    
}

void RootFrame::OnItemDeSelect(wxThumbnailEvent& event) {
    selectedItem = 0;
}

void RootFrame::OnItemClick(wxThumbnailEvent& event) {
//    int itemID = event.GetIndex();

}

void RootFrame::OnItemDoubleClick(wxThumbnailEvent& event) {
    int itemID = event.GetIndex();

    wxString fullPath = ((FireItem*)scrolledWindow->GetItem(itemID))->getName();
    wxString path = firewatch.getPath();
    // strip path and additionally introduced file separator (+1)    
    wxString file = fullPath.Mid(path.Length()+1);
    
    std::vector<FireResult>& results  = firewatch.retrieve(file);
    if (results.empty()) {
        wxMessageBox(_("something went wrong...\nMaybe you don't have enough access rights in the Fire image folder?"));
    } else {
        selectedItem = 0;
        displayFireResults(results);
    }
}

void RootFrame::OnItemRightClick(wxThumbnailEvent& event) {
    selectedItem = (FireItem*) scrolledWindow->GetItem(event.GetIndex());
    GetToolBar()->EnableTool(ToolBarSelect, true);
    GetToolBar()->EnableTool(ToolBarRetrieve, true);

    ContextMenu();
    
}


void RootFrame::OnItemContextClick(wxContextMenuEvent& event){
    if (selectedItem != 0) {

      //if the context menu doesn't appear close to the selected image  -> calculate position and give it as parameter
      ContextMenu();
    }
}

void RootFrame::ContextMenu(const wxPoint& pos){
    wxMenu* contextMenu = new wxMenu;
    contextMenu->Append(ToolBarSelect, _("Select region..."), _T(""), wxITEM_NORMAL);
    contextMenu->Append(ToolBarRetrieve, _("Retrieve similar..."), _T(""), wxITEM_NORMAL);
    wxWindow* popupContextMenu = new wxWindow(this, wxID_ANY);
    popupContextMenu->PopupMenu(contextMenu, pos);
    popupContextMenu->Show(false);
    delete popupContextMenu;
    delete contextMenu;
}


/*!
 * wxEVT_COMMAND_SPINCTRL_UPDATED event handler for ID_SPINCTRL
 */

void RootFrame::OnFireResultsUpdated( wxSpinEvent& event ) {
    fireResultCount->SetValue(firewatch.setResultCount(fireResultCount->GetValue()));
}


/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for ToolBarBrowse
 */

void RootFrame::OnToolbarBrowseClick( wxCommandEvent& event ) {
    // show browse dialog
    if (browseDialog == 0) {
        browseDialog = new wxThumbnailBrowserDialog(this, wxID_ANY);
        wxString initialPath = wxGetCwd();
        if (wxDirExists(initialPath)) browseDialog->SetSelection(initialPath);
    }
    
    if (wxID_OK == browseDialog->ShowModal()) {
        wxString sel = browseDialog->GetSelection();
        if (sel.IsEmpty()) return;
        // copy image to fire folder -> check access rights
        wxString filename = sel.AfterLast(wxFILE_SEP_PATH);
        wxString newFilename = firewatch.getPath() + wxFILE_SEP_PATH + filename;
        // check if file already exists
        /*if (wxFileExists(newFilename)) {
            wxMessageBox(_("a file with this name already exists!"));
            return;
        }*/
        // copy image into Fire location and check if it worked
        if (!wxCopyFile(sel, newFilename, false)) {
            wxMessageBox(_("could not upload image!\nDo you have enough access rights in the Fire image folder?"));
            return;            
        }
        std::vector<FireResult>& results  = firewatch.retrieve(newFilename, true, true);
         if (results.empty()) {
            wxMessageBox(_("something went wrong...\nMaybe you don't have enough access rights in the Fire image folder?"));
        } else {
            selectedItem = 0;
            displayFireResults(results);
        }       
    }
}


/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for ToolBarSelect
 */

void RootFrame::OnToolbarSelect( wxCommandEvent& event ) {
    if (selectDialog == 0) {
        selectDialog = new SelectDialog(this, wxID_ANY);
    }
    
    if (selectedItem != 0) {
        selectDialog->setFireItem(*selectedItem);
        selectDialog->Show();
    }
}

/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for ToolBarRetrieve
 */

void RootFrame::OnToolbarRetrieveSimilar (wxCommandEvent& event ){
    if (selectedItem != 0) {
        wxString fullPath = selectedItem->getName();
        wxString path = firewatch.getPath();
        // strip path and additionally introduced file separator (+1)    
        wxString file = fullPath.Mid(path.Length()+1);
      
        std::vector<FireResult>& results  = firewatch.retrieve(file);
        if (results.empty()) {
	  wxMessageBox(_("something went wrong...\nMaybe you don't have enough access rights in the Fire image folder?"));
        } else {
	  selectedItem = 0;
	  displayFireResults(results);
        }
    }
}


/*!
 * wxEVT_IDLE event handler for ID_FRAME
 */

void RootFrame::OnIdle( wxIdleEvent& event ) {
  if(selectedItem == 0){ 
    GetToolBar()->EnableTool(ToolBarSelect, false);
    GetToolBar()->EnableTool(ToolBarRetrieve, false);
  }
 }


/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENUSETTINGS_SERVER
 */

void RootFrame::OnMenuSettingsServer( wxCommandEvent& event )
{
////@begin wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENUSETTINGS_SERVER in RootFrame.
    // Before editing this code, remove the block markers.
    event.Skip();
////@end wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENUSETTINGS_SERVER in RootFrame. 
}


