/* 
 *  Copyright (C) 2006 DFKI GmbH
 *  Image Understanding and Pattern Recognition Lab
 *  Author: Christian Kofler <christian.kofler@dfki.de>
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


// Generated by DialogBlocks (Personal Edition), Do 26 Jan 2006 14:22:16 CET

#ifndef _ROOTFRAME_H_
#define _ROOTFRAME_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "RootFrame.cc"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/frame.h"
#include "wx/toolbar.h"
#include "wx/spinctrl.h"
////@end includes

#include "thumbnaildlg.h"
#include "FireWatch.h"
#include "FireItem.h"
#include "SelectDialog.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxSpinCtrl;
class wxThumbnailCtrl;
////@end forward declarations

class wxThumbnailEvent;

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_FRAME 10009
#define SYMBOL_ROOTFRAME_STYLE wxDEFAULT_FRAME_STYLE|wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxMINIMIZE|wxMAXIMIZE|wxMINIMIZE_BOX|wxMAXIMIZE_BOX|wxCLOSE_BOX
#define SYMBOL_ROOTFRAME_TITLE _("FireWatch")
#define SYMBOL_ROOTFRAME_IDNAME ID_FRAME
#define SYMBOL_ROOTFRAME_SIZE wxDefaultSize
#define SYMBOL_ROOTFRAME_POSITION wxDefaultPosition
#define MENU_FILE_LOAD 10000
#define ID_MENU_CONNECT 10021
#define MENU_FILE_EXIT 10001
#define ID_MENUSETTINGS_SERVER 10017
#define ID_MENU 10003
#define ID_TOOLBAR1 10011
#define ToolBarRandom 10012
#define ToolBarRetrieve 10016
#define ToolBarBrowse 10006
#define ToolBarSelect 10014
#define ID_SPINCTRL 10004
#define ID_SCROLLEDWINDOW1 10005
#define ID_SLIDER 10002
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * RootFrame class declaration
 */

class RootFrame: public wxFrame
{    
    DECLARE_CLASS( RootFrame )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    RootFrame( );
    RootFrame( wxWindow* parent, wxWindowID id = SYMBOL_ROOTFRAME_IDNAME, const wxString& caption = SYMBOL_ROOTFRAME_TITLE, const wxPoint& pos = SYMBOL_ROOTFRAME_POSITION, const wxSize& size = SYMBOL_ROOTFRAME_SIZE, long style = SYMBOL_ROOTFRAME_STYLE );

    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_ROOTFRAME_IDNAME, const wxString& caption = SYMBOL_ROOTFRAME_TITLE, const wxPoint& pos = SYMBOL_ROOTFRAME_POSITION, const wxSize& size = SYMBOL_ROOTFRAME_SIZE, long style = SYMBOL_ROOTFRAME_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin RootFrame event handler declarations

    /// wxEVT_IDLE event handler for ID_FRAME
    void OnIdle( wxIdleEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for MENU_FILE_LOAD
    void OnMenuFileLoad( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for MENU_FILE_EXIT
    void OnMenuFileExitClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENUSETTINGS_SERVER
    void OnMenuSettingsServer( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENU
    void OnMenuClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ToolBarRandom
    void OnRandom( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ToolBarRetrieve
    void OnToolbarRetrieveSimilar( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ToolBarBrowse
    void OnToolbarBrowseClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ToolBarSelect
    void OnToolbarSelect( wxCommandEvent& event );

    /// wxEVT_COMMAND_SPINCTRL_UPDATED event handler for ID_SPINCTRL
    void OnFireResultsUpdated( wxSpinEvent& event );

    /// wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER
    void OnZoom( wxCommandEvent& event );

////@end RootFrame event handler declarations

////@begin RootFrame member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end RootFrame member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

    void initFireWatch(wxString host, unsigned short port);
    
    void displayFireResults(std::vector<FireResult>& results);
    
    void sendNewImage(wxString);
    
    void OnItemSelect(wxThumbnailEvent& event);
    void OnItemDeSelect(wxThumbnailEvent& event);
    void OnItemClick(wxThumbnailEvent& event);
    void OnItemDoubleClick(wxThumbnailEvent& event);
    void OnItemRightClick(wxThumbnailEvent& event);
    void OnItemContextClick(wxContextMenuEvent& event);
 
    void ContextMenu(const wxPoint& pos = wxDefaultPosition);
    
private:
    
////@begin RootFrame member variables
    wxSpinCtrl* fireResultCount;
    wxThumbnailCtrl* scrolledWindow;
    wxSlider* zoomSlider;
////@end RootFrame member variables

    wxThumbnailBrowserDialog* browseDialog;
    SelectDialog* selectDialog;
    FireWatch firewatch;
    float scaleFactor;
    FireItem* selectedItem;

};

#endif
    // _ROOTFRAME_H_
