/* 
 *  Copyright (C) 2006 DFKI GmbH
 *  Image Understanding and Pattern Recognition Lab
 *  Author: Christian Kofler <christian.kofler@dfki.de>
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


// Generated by DialogBlocks (Personal Edition), Di 31 Jan 2006 14:34:02 CET

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "SelectDialog.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "SelectDialog.h"
#include "RootFrame.h"
#include <wx/filesys.h>

////@begin XPM images
////@end XPM images

/*!
 * SelectDialog type definition
 */

IMPLEMENT_DYNAMIC_CLASS( SelectDialog, wxDialog )

/*!
 * SelectDialog event table definition
 */

BEGIN_EVENT_TABLE( SelectDialog, wxDialog )

////@begin SelectDialog event table entries
    EVT_CLOSE( SelectDialog::OnCloseWindow )
    EVT_IDLE( SelectDialog::OnIdle )

    EVT_MOUSE_EVENTS( SelectDialog::OnMouse )

    EVT_SLIDER( ID_SLIDER_SELECTION, SelectDialog::OnZoom )

    EVT_BUTTON( ID_CLEAR_SELECTION, SelectDialog::OnClearSelection )

    EVT_BUTTON( ID_SEND_SELECTION, SelectDialog::OnSendSelection )

    EVT_BUTTON( ID_BUTTON3, SelectDialog::OnExit )

////@end SelectDialog event table entries

END_EVENT_TABLE()

/*!
 * SelectDialog constructors
 */

SelectDialog::SelectDialog( )
{
}

SelectDialog::SelectDialog( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Create(parent, id, caption, pos, size, style);
}

/*!
 * SelectDialog creator
 */

bool SelectDialog::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin SelectDialog member initialisation
    selectCanvas = NULL;
    zoomSlider = NULL;
////@end SelectDialog member initialisation

////@begin SelectDialog creation
    SetExtraStyle(GetExtraStyle()|wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    GetSizer()->Fit(this);
    GetSizer()->SetSizeHints(this);
////@end SelectDialog creation


    rootFrame = (RootFrame*) parent;

    return TRUE;
}

/*!
 * Control creation for SelectDialog
 */

void SelectDialog::CreateControls()
{    
////@begin SelectDialog content construction
    // Generated by DialogBlocks, Do 09 Feb 2006 17:10:53 CET (Personal Edition)

    SelectDialog* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    selectCanvas = new SelectCanvas( itemDialog1, ID_SELECTCANVAS, wxDefaultPosition, wxSize(500, 400), wxSUNKEN_BORDER|wxHSCROLL|wxVSCROLL );
    itemBoxSizer2->Add(selectCanvas, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);
    selectCanvas->SetScrollbars(1, 1, 0, 0);

    wxBoxSizer* itemBoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer4, 0, wxALIGN_RIGHT|wxALL, 0);

    wxStaticText* itemStaticText5 = new wxStaticText( itemDialog1, wxID_STATIC, _("-"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(itemStaticText5, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    zoomSlider = new wxSlider( itemDialog1, ID_SLIDER_SELECTION, 100, 5, 200, wxDefaultPosition, wxSize(150, 15), wxNO_BORDER );
    itemBoxSizer4->Add(zoomSlider, 0, wxALIGN_CENTER_VERTICAL, 0);

    wxStaticText* itemStaticText7 = new wxStaticText( itemDialog1, wxID_STATIC, _("+"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(itemStaticText7, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxBoxSizer* itemBoxSizer8 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer8, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 2);

    wxButton* itemButton9 = new wxButton( itemDialog1, ID_CLEAR_SELECTION, _("Clear Selection"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer8->Add(itemButton9, 0, wxALIGN_CENTER_VERTICAL|wxALL, 2);

    wxButton* itemButton10 = new wxButton( itemDialog1, ID_SEND_SELECTION, _("Send Selection"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer8->Add(itemButton10, 0, wxALIGN_CENTER_VERTICAL|wxALL, 2);

    itemBoxSizer8->Add(40, 5, 0, wxGROW|wxALL, 5);

    wxButton* itemButton12 = new wxButton( itemDialog1, ID_BUTTON3, _("exit"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer8->Add(itemButton12, 0, wxALIGN_CENTER_VERTICAL|wxALL, 2);

////@end SelectDialog content construction
}

/*!
 * Should we show tooltips?
 */

bool SelectDialog::ShowToolTips()
{
    return TRUE;
}

/*!
 * Get bitmap resources
 */

wxBitmap SelectDialog::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin SelectDialog bitmap retrieval
    return wxNullBitmap;
////@end SelectDialog bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon SelectDialog::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin SelectDialog icon retrieval
    return wxNullIcon;
////@end SelectDialog icon retrieval
}
/*!
 * All mouse events event handler for ID_SCROLLEDWINDOW
 */

void SelectDialog::OnMouse( wxMouseEvent& event ) {
    // this method is left intentionally blank ;)
    // moved to SelectCanvas::OnMouse
    ;
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON
 */

void SelectDialog::OnClearSelection( wxCommandEvent& event ) {
    selectCanvas->clearSelection();
    Refresh();
}

/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON1
 */

void SelectDialog::OnSendSelection( wxCommandEvent& event ) {
    wxString newFile = selectCanvas->getSelectedImageName();
    if (newFile.IsEmpty()) {
        wxMessageBox(_("Selection could not be sent!\nDo you have enough access rights in the Fire image folder?"));
    } else {
        rootFrame->sendNewImage(newFile);
    }
}

/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON3
 */

void SelectDialog::OnExit( wxCommandEvent& event ) {
    Show(false);
}


/*!
 * wxEVT_CLOSE_WINDOW event handler for ID_DIALOG
 */

void SelectDialog::OnCloseWindow( wxCloseEvent& event )
{
////@begin wxEVT_CLOSE_WINDOW event handler for ID_DIALOG in SelectDialog.
    // Before editing this code, remove the block markers.
    event.Skip();
////@end wxEVT_CLOSE_WINDOW event handler for ID_DIALOG in SelectDialog. 
}

/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER
 */

void SelectDialog::OnZoom( wxCommandEvent& event ) {
    selectCanvas->updateZoom((float) zoomSlider->GetValue()/100.f);
}

/*!
 * wxEVT_IDLE event handler for ID_DIALOG
 */

void SelectDialog::OnIdle( wxIdleEvent& event ) {
    if(selectCanvas->hasSelection()) {
        FindWindow(ID_CLEAR_SELECTION)->Enable();
        FindWindow(ID_SEND_SELECTION)->Enable();
    } else {
        FindWindow(ID_CLEAR_SELECTION)->Enable(false);
        FindWindow(ID_SEND_SELECTION)->Enable(false);
    }
}


BEGIN_EVENT_TABLE( SelectCanvas, wxScrolledWindow )
    EVT_MOUSE_EVENTS( SelectCanvas::OnMouse )
    EVT_PAINT( SelectCanvas::OnPaint )
END_EVENT_TABLE()


SelectCanvas::SelectCanvas(wxWindow* _parent, wxWindowID id,const wxPoint& pos, const wxSize& size, const long style)
                            : wxScrolledWindow(_parent, id, pos, size, style) {
                          
    parent = 0;      
    parent = (SelectDialog*)_parent;
    selecting = false;
    selected = false;
    startPoint.x = 0;
    startPoint.y = 0;
    currentPoint.x = 0;
    currentPoint.y = 0;
    endPoint.x = 0;
    endPoint.y = 0;
}

void SelectCanvas::setFireItem(const FireItem& item) {
    clearSelection();
    fireItem = item;
    fireItem.setScale(1.f);
    SetVirtualSize(fireItem.getThumbnail().GetWidth(), fireItem.getThumbnail().GetHeight());
    Refresh();
}

void SelectCanvas::updateZoom(float scale) {
    //selected = false;
    fireItem.setScale(scale);
    SetVirtualSize(fireItem.getThumbnail().GetWidth(), fireItem.getThumbnail().GetHeight());
    Refresh();
}

void SelectCanvas::clearSelection() {
    selected = false;
    startPoint.x = 0;
    startPoint.y = 0;
    endPoint.x = 0;
    endPoint.y = 0;
}

wxString SelectCanvas::getSelectedImageName() {
    if (!selected) return wxString(wxT(""));
    wxRect selection(startPoint, endPoint);
    wxImage subimage = fireItem.getImage().GetSubImage(selection);
    wxString pathname = fireItem.getName().BeforeLast(wxFILE_SEP_PATH);
    wxString filename = fireItem.getName().AfterLast(wxFILE_SEP_PATH);
    wxString suffix = filename.AfterLast(wxFILE_SEP_EXT);
    wxString base = filename.BeforeLast(wxFILE_SEP_EXT);
    // save in Fire folder, it goes there anyway
    wxString newFilename = pathname + wxFILE_SEP_PATH + base + wxT("part") + wxFILE_SEP_EXT + suffix;
    // if the file cannot be saved, return empty string
    if(!subimage.SaveFile(newFilename)) return wxString(wxT(""));
    
    return newFilename;
}


void SelectCanvas::OnMouse( wxMouseEvent& event ) {
    wxClientDC dc(this);
    DoPrepareDC(dc);
    
    // Take into account scrolling    
    currentPoint = event.GetLogicalPosition(dc);
    
    // restrict selection to actual image!
    if (currentPoint.x < 0) currentPoint.x = 0;
    else if (currentPoint.x > fireItem.getThumbnail().GetWidth()) currentPoint.x = fireItem.getThumbnail().GetWidth();
    if (currentPoint.y < 0) currentPoint.y = 0;
    else if (currentPoint.y > fireItem.getThumbnail().GetHeight()) currentPoint.y = fireItem.getThumbnail().GetHeight();

    currentPoint.x = (int) (((float)currentPoint.x) / fireItem.getScale());
    currentPoint.y = (int) (((float)currentPoint.y) / fireItem.getScale());
    
    int viewStartX, viewStartY ; 
    GetViewStart(&viewStartX, &viewStartY);
    
    if (event.GetWheelRotation()<0){
	Scroll(-1,viewStartY+50);
    }
    if (event.GetWheelRotation()>0){
	Scroll(-1,viewStartY-50);
    }
    
    if (event.Dragging() && event.LeftIsDown()) {
        if (selected) selected = false;
        if (!selecting) {
            selecting = true;
            startPoint = currentPoint;
        } 
	else {
	    if ((event.GetX() > GetClientSize().GetWidth()) && (currentPoint.x < fireItem.getThumbnail().GetWidth())){ 
		Scroll(viewStartX+10,-1);
	    }
	    if ((event.GetY() > GetClientSize().GetHeight()) && (currentPoint.y < fireItem.getThumbnail().GetHeight())){ 
		Scroll(-1,viewStartY+10);
	    }
 	    if ((event.GetX() < 0) && (currentPoint.x >= 0)){ 
		if(viewStartX>=10) Scroll(viewStartX-10,-1);
		else Scroll(0,-1);
	    }
	    if ((event.GetY() < 0 ) && (currentPoint.y >= 0)){ 
		if(viewStartY>=10) Scroll(-1,viewStartY-10);
		else Scroll(-1,0);
	    }
	    Refresh();
        }
    } else if (event.LeftUp()) {
        if (selecting) {
            selecting = false;
            endPoint = currentPoint;
            selected = true;
            Refresh();
        }
    }
}

void SelectCanvas::OnPaint(wxPaintEvent& WXUNUSED(event)) {
    wxPaintDC dc(this);

    PrepareDC(dc);
 
    dc.DrawBitmap(fireItem.getThumbnail(), 1, 1);

    dc.SetBrush(*wxTRANSPARENT_BRUSH); 
 
    if (selecting) {
	wxPen* tmpLine = new wxPen (*wxRED, 1, wxSHORT_DASH);
        dc.SetPen(*tmpLine);
//        dc.DrawRectangle(startPoint.x, startPoint.y, currentPoint.x - startPoint.x, currentPoint.y - startPoint.y);
        dc.DrawRectangle((int) (((float)startPoint.x) * fireItem.getScale()),
            (int) (((float)startPoint.y) * fireItem.getScale()), 
            (int) (((float)(currentPoint.x - startPoint.x)) * fireItem.getScale()),
            (int) (((float)(currentPoint.y - startPoint.y)) * fireItem.getScale()));
	delete tmpLine;
    }
    
    if (selected) {
        dc.SetPen(*wxRED_PEN);
        dc.DrawRectangle((int) (((float)startPoint.x) * fireItem.getScale()),
            (int) (((float)startPoint.y) * fireItem.getScale()), 
            (int) (((float)(endPoint.x - startPoint.x)) * fireItem.getScale()),
            (int) (((float)(endPoint.y - startPoint.y)) * fireItem.getScale()));
    }
 

}





